namespace Gate {

/*
 * sReLXg
 */
  public interface Context {
    bool Confirm();  // RČ
    void Lock();     // Q[gJ
    void Unlock();   // Q[g
    void Alarm();    // x!!!
    void ThankYou(); // ǉ劽}
  }

  public enum StateCode { Close, Open }

  public interface State {
    StateCode Code { get; }
    // CxgAStateԂׂ
    State Coin(Context ctx); // Coinꂽ
    State Pass(Context ctx); // Ԃʉ߂
  }

/*
 * ꂱa@Q[g̎̂ȂB
 */

  // Close
  public class CloseState : State {
    public StateCode Code { get { return StateCode.Close; } }
    public State Coin(Context ctx) { 
      if ( ctx.Confirm() ) { 
        ctx.Unlock(); 
        return StateMachine.Open;
      }
      return this;
    }
    public State Pass(Context ctx) {
      ctx.Alarm();
      return this;
    }
  }

  // Open
  public class OpenState : State {
    public StateCode Code { get { return StateCode.Open; } }
    public State Coin(Context ctx) {
      ctx.ThankYou();
      return this;
    }
    public State Pass(Context ctx) { 
      ctx.Lock();
      return StateMachine.Close;
    }
  }

/*
 * ԑJڋ@B͏LStateB
 */
  public class StateMachine {
    internal static State Close = new CloseState();
    internal static State Open  = new OpenState();
    private State state_ = Close; // 
    public StateCode Current { get { return state_.Code; } }
    // StatẽCxgnhĂтAVȏԂɑJڂB
    public void Coin(Context ctx) { state_ = state_.Coin(ctx); }
    public void Pass(Context ctx) { state_ = state_.Pass(ctx); }
  }
}
